diff -urN clamav-devel-jm2/clamav-milter/clamav-milter.c clamav-devel-jm3/clamav-milter/clamav-milter.c
--- clamav-devel-jm2/clamav-milter/clamav-milter.c	Wed May 12 22:59:43 2004
+++ clamav-devel-jm3/clamav-milter/clamav-milter.c	Wed May 12 23:01:26 2004
@@ -2353,36 +2353,20 @@
 			/*
 			 * Setup err as a list of recipients
 			 */
-			err = (char *)cli_malloc(1024);
-			ALLOC_CHECK("cli_malloc",err,1);
 
-			/*
-			 * Use snprintf rather than printf since we don't know the
-			 * length of privdata->from and may get a buffer overrun
-			 */
-			snprintf(err, 1023, "Intercepted virus from %s to",
+			asprintf(&err,"Intercepted virus from %s to",
 				privdata->from);
 
-			ptr = strchr(err, '\0');
-
-			i = 1024;
-
 			for(to = privdata->to; *to; to++) {
-				/*
-				 * Re-alloc if we are about run out of buffer space
-				 */
-				if(&ptr[strlen(*to) + 2] >= &err[i]) {
-					i += 1024;
-					p = NULL;
-					p = cli_realloc(err, i);
-					ALLOC_CHECK("cli_realloc",p,1);
-					err = ptr;
-					ptr = strchr(err, '\0');
-				}
-				ptr = strrcpy(ptr, " ");
-				ptr = strrcpy(ptr, *to);
+				ptr = NULL;
+				asprintf(&ptr,"%s %s",err,*to);
+				free(err);
+				err = ptr;
 			}
-			(void)strcpy(ptr, "\n");
+			err = NULL;
+			asprintf(&err,"%s\n",ptr);
+			free(ptr);
+			ptr = NULL;
 
 			/* Include the sendmail queue ID in the log */
 			syslog(LOG_NOTICE, "%s: %s %s", privdata->envid, mess, err);
@@ -2707,9 +2691,10 @@
 static ssize_t
 clamfi_send(struct privdata *privdata, size_t len, const char *format, ...)
 {
-	char output[BUFSIZ];
+	char * output = NULL;
 	const char *ptr;
 	ssize_t ret = 0;
+	int ret_code = 0;
 
 	assert(format != NULL);
 
@@ -2723,7 +2708,9 @@
 		va_list argp;
 
 		va_start(argp, format);
-		vsnprintf(output, sizeof(output), format, argp);
+		vasprintf(&output, format, argp);
+		ALLOC_CHECK("vasprintf",output,1);
+			
 		va_end(argp);
 
 		len = strlen(output);
@@ -2785,13 +2772,23 @@
 			}
 			checkClamd();
 
-			return -1;
+			ret_code = -1;
+			goto cleanup;
 		}
 		ret += nbytes;
 		len -= nbytes;
 		ptr = &ptr[nbytes];
 
 		privdata->numBytes += nbytes;
+	}
+cleanup:
+	if(output)
+		free(output);
+	if(ret_code){
+#ifdef CL_DEBUG
+		cli_dbgmsg("vasprintf: %s\n",output);
+#endif
+		return(-1);
 	}
 	return ret;
 }
